import sys
import glob
import numpy as np
import datetime
#
import Station as ST
import AllStations as AS
#
GRDCPath="/home/polcher/WORK/Python/GRDC/Files"
GRDCfile="GRDC_Monthly_Jan20.nc"
#
GRDC = AS.AllStations(Source=GRDCPath)
#
for f in glob.glob(GRDCPath+'/*.txt') :
    GRDC.add(ST.Station("GRDCascii",f))
#
#
# Compute the over all time axis.
#
FirstDate=GRDC.FirstDate()
#
nbmonth = int((GRDC.LastDate()-GRDC.FirstDate()).days/365)*12+12
nbstations = GRDC.nbstations
print("Number of stations :", nbstations)
print("Data covers the period :", GRDC.FirstDate(), " to ", GRDC.LastDate(), ' or ', nbmonth, ' month.')
#
# Create a global calendar in which all observations fit
#
AllDates=[]
y=GRDC.FirstDate().year
m=1
d=15
for i in range(nbmonth):
    dm=i%12
    dy=int((i-dm)/12)
    AllDates.append(datetime.datetime(y+dy, m+dm, d))
print("New time axis goes from ", AllDates[0]," to ", AllDates[-1])
#
# Dump all stations into a netCDF file
#
hist="GRDC Monthly River Discharge Received in January 2020"
GRDC.dumpnetcdf(AllDates, GRDCfile, hist)
