import sys
import glob
import numpy as np
import datetime
#
import Station as ST
import AllStations as AS
#
SpainPath="/home/polcher/WORK/Python/GRDC/data-all-1900-2014.json"
Spainfile="Spain_Monthly_May20.nc"
#
#
#
Spain = AS.AllStations(Source=SpainPath)
#
for f in glob.glob(SpainPath+'/*.json') :
    Spain.add(ST.Station("SpainJson", f, regioncode=62, countrycode="ES"))
#
# Compute the over all time axis.
#
FirstDate=Spain.FirstDate()
#
nbmonth = int((Spain.LastDate()-Spain.FirstDate()).days/365)*12+12
nbstations = Spain.nbstations
print("Number of stations :", nbstations)
print("Data covers the period :", Spain.FirstDate(), " to ", Spain.LastDate(), ' or ', nbmonth, ' month.')
#
#
# Create a global calendar in which all observations fit
#
AllDates=[]
y=Spain.FirstDate().year
m=1
d=15
for i in range(nbmonth):
    dm=i%12
    dy=int((i-dm)/12)
    AllDates.append(datetime.datetime(y+dy, m+dm, d))
print("New time axis goes from ", AllDates[0]," to ", AllDates[-1])
#
# Dump all stations into a netCDF file
#
hist="Spanish data obtained from Observatorio del Ebro in May 2020. Downloaded in 2014 by Pere Quintana"
Spain.dumpnetcdf(AllDates, Spainfile, hist)
