#
import datetime
#
import Station as ST
import AllStations as AS
#
import configparser
config=configparser.ConfigParser()
config.read("MergeStations.def")
#
#
#
FileA=config.get("OverAll","FileA")
FileB=config.get("OverAll","FileB")
#
OutFile=config.get("OverAll","OutFile")
#
MinDistance=config.getfloat("OverAll","MinDistance",fallback=1000.)
UpAreaError=config.getfloat("OverAll","UpAreaError",fallback=10.)
interactive=config.getboolean("OverAll","Interactive",fallback=False)
#
A=AS.AllStations()
A.fetchnetcdf(FileA)
B=AS.AllStations()
B.fetchnetcdf(FileB)
#
AclosetoB, BclosetoA = AS.closeto(A, B, distance=5*MinDistance)
#
# Try to pair stations which are close to each other. The various metadate are compared.
#
pairs, metachoice = AS.PairAtoB(A, B, AclosetoB, BclosetoA, MinDistance, UpAreaError, interactive=interactive)
#
# Concatenate all stations which are not found to pair.
#
C=AS.concatenate(A, B, pairs, Sources=FileA+"+"+FileB)
#
# Merge the data if the station which where paired
#
C=AS.mergedata(A, B, C, pairs, metachoice, verbose=True)
#
# Check the station numbers and complete if needed
#
C=AS.stnnbchecker(C)
#
# Create a global calendar in which all observations fit
#
print("Number of stations in A = ", A.nbstations," in B = ", B.nbstations, " Merged set has : ", C.nbstations)
print("Time range of input : A=", A.FirstDate(), "-", A.LastDate()," B=", B.FirstDate(), "-", B.LastDate())
nbmonth = int((C.LastDate()-C.FirstDate()).days/365)*12+12
print("Data coverd by merged dataset :", C.FirstDate(), " to ", C.LastDate(), ' or ', nbmonth, ' month.')
AllDates=[]
y=C.FirstDate().year
m=1
d=15
for i in range(nbmonth):
    dm=i%12
    dy=int((i-dm)/12)+1
    AllDates.append(datetime.datetime(y+dy, m+dm, d))
#
C.dumpnetcdf(AllDates, OutFile, "Merge of "+FileA+" and "+FileB)
