from __future__ import print_function
import argparse
import logging
	
parser   = argparse.ArgumentParser()
add      = parser.add_argument
defaults = parser.set_defaults
parse    = parser.parse_args
	
add("--dt", type=float, help='Time step in seconds')
add("--debug", default=[], type=lambda str : str.split(','),
    help='Comma-separated list of modules that will display debug information')
	
def noop(*args, **kwargs): pass

def ignore_first(fun):
    def f(self, *args, **kwargs) : fun(*args, **kwargs)
    return f
	
def getLogger(modulename='main'):
    # two logger are created
    # the 'master' logger will be muted if current MPI process is not master
    # log your messages through master two avoid massive logs with 1000+ MPI processes
    master, world = logging.getLogger(modulename), logging.getLogger('%s.world'%modulename) 
    arglist = parser.parse_args()
    debug=False
    print(modulename)
##    if modulename in ['RoutingPreProc.%s'%name for name in arglist.debug] : debug=True
    if modulename in arglist.debug : debug=True
    if 'all' in arglist.debug : debug=True
    if debug:
        #        print('Debug ON for module %s'%modulename)
        master.setLevel(logging.DEBUG)
        world.setLevel(logging.DEBUG)
    else:
        master.setLevel(logging.INFO)
        world.setLevel(logging.INFO)
    masters[modulename]=master
    return master, world

def not_master():
    for logger in masters.values():
        logger.setLevel(logging.CRITICAL)
	
masters = {}
logging.basicConfig()
